Package: rjags
Version: 4-17
Date: 2025-03-24
Title: Bayesian Graphical Models using MCMC
Authors@R: c(person("Martyn", "Plummer", role=c("aut","cre"),
                    email="martyn.plummer@gmail.com"),
             person("Alexey", "Stukalov", role="ctb"),
             person("Matt", "Denwood", role="ctb"))
Depends: R (>= 2.14.0), coda (>= 0.13)
SystemRequirements: JAGS 4.x.y
URL: https://mcmc-jags.sourceforge.io
Suggests: tcltk
Description: Interface to the JAGS MCMC library.
License: GPL (== 2)
NeedsCompilation: yes
Packaged: 2025-03-24 13:34:40 UTC; martyn
Author: Martyn Plummer [aut, cre],
  Alexey Stukalov [ctb],
  Matt Denwood [ctb]
Maintainer: Martyn Plummer <martyn.plummer@gmail.com>
Repository: CRAN
Date/Publication: 2025-03-24 15:10:02 UTC
Built: R 4.6.0; aarch64-apple-darwin23; 2026-04-25 23:17:14 UTC; unix
Archs: rjags.so.dSYM

Package: rjags
Version: 4-17
Date: 2025-03-24
Title: Bayesian Graphical Models using MCMC
Authors@R: c(person("Martyn", "Plummer", role=c("aut","cre"),
                    email="martyn.plummer@gmail.com"),
             person("Alexey", "Stukalov", role="ctb"),
             person("Matt", "Denwood", role="ctb"))
Depends: R (>= 2.14.0), coda (>= 0.13)
SystemRequirements: JAGS 4.x.y
URL: https://mcmc-jags.sourceforge.io
Suggests: tcltk
Description: Interface to the JAGS MCMC library.
License: GPL (== 2)
NeedsCompilation: yes
Packaged: 2025-03-24 13:34:40 UTC; martyn
Author: Martyn Plummer [aut, cre],
  Alexey Stukalov [ctb],
  Matt Denwood [ctb]
Maintainer: Martyn Plummer <martyn.plummer@gmail.com>
Repository: CRAN
Date/Publication: 2025-03-24 15:10:02 UTC

if(.Platform$OS.type == "windows") {
    importFrom(utils, readRegistry, winProgressBar, setWinProgressBar,
               packageVersion, file_test)
}
importFrom(utils, txtProgressBar, setTxtProgressBar)
importFrom(stats, variable.names, sd, update)
importFrom(coda, as.mcmc.list, as.mcmc, mcmc.list, mcmc, spectrum0,
           nvar, "varnames<-")
export (
  jags.model,
  jags.samples,
  coda.samples,
  load.module,
  unload.module,
  list.modules,
  dic.samples,
  diffdic,
  adapt,
  list.samplers,
  list.factories,
  set.factory,
  read.data,
  read.jagsdata,
  read.bugsdata,
  parallel.seeds,
  jags.version
)
S3method(print, jags)
S3method(coef, jags)
S3method(update, jags)
S3method(variable.names, jags)
S3method(print, mcarray)
S3method(summary, mcarray)
S3method(print, summary.mcarray)
S3method(as.mcmc.list, mcarray)
S3method("-", dic)
S3method(print, dic)
S3method(print, diffdic)

The rjags package is an interface to the JAGS library.  In order to
build a binary package, or install from source, you must have a matching
installation of the JAGS library.

Windows
-------

At compile time, there is no way for Windows to guess where the JAGS
library is installed, so you must supply the location yourself using
the make variable JAGS_ROOT, defining it in the file HOME/.R/Makevars.win

JAGS_ROOT=c:\Program Files\JAGS\JAGS-3.1.0

Unix
----

The configure script will try to guess the location of the JAGS
library installation. It will look in /<prefix>/<lib>, where

- <prefix> is the determined from the location of the jags
  script that launches the command line interface.

  For example, if this is "/usr/local/bin/jags", then prefix will
  be "/usr/local"

- <lib> is derived from the value of "LIBnn", returned by 
  "R CMD config LIBnn".

  This is particularly important on 64-bit unix, where R is 
  installed by default in /usr/local/lib64 and LIBnn is "lib64"

The configure script will also look for JAGS headers in
/<prefix>/include/JAGS

If the configure script fails to find the JAGS headers or library,
you can set the environment variables JAGS_INCLUDE and JAGS_LIB
to point to the correct directory.

Alternatively, you can use the configure options

--with-jags-include=/path/to/jags/headers 
                    (default /usr/local/include/JAGS)

--with-jags-lib=/path/to/jags/library
                (default /usr/local/[lib|lib64])

These options are onto the rjags configure script with:
"R CMD INSTALL --configure-args='--with-jags...'

Exceptionally, you may need to set the location of the JAGS modules.
But this will only be necessary if you reset moddir when installing
JAGS. This can be done by setting the environment variabel JAGS_MODULES
or by using the configure option

--with-jags-modules=/path/to/jags/modules
                    (default /usr/local/[lib|lib64]/JAGS/modules-w.y.z)
                     where w.y.z is the version number of JAGS

updatePB <- function(start.iter, end.iter, adapting)
{
  tcltk:::tkProgressBar(title=ifelse(adapting, "Adapting","Updating"),
                        label="Iteration 0", min = start.iter, max=end.iter,
                        initial=start.iter)
}

setPB <- function(pb, iter)
{
  tcltk:::setTkProgressBar(pb, iter, label=paste("Iteration",iter))
}

#  R package rjags file R/mcarray.R
#  Copyright (C) 2007-2009 Martyn Plummer
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License version
#  2 as published by the Free Software Foundation.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  A copy of the GNU General Public License is available at
#  http://www.r-project.org/Licenses/
#

print.mcarray <- function(x, ...)
{
    if (!checkdimtags(x)) {
        NextMethod()
    }
    else {
        cat("mcarray:",
            sprintf("%s", attr(x, "stat")),
            sprintf("%s", attr(x, "summary")), "\n\n")
        
        print(collapse(x, keep.tags="value", FUN=mean))

        tags <- dimtags(x)
        drop.dims <- tags %in% c("iteration","chain")
        if (any(drop.dims)) {
            cat("\nMarginalizing over:",
                paste(tags[drop.dims], "(", dim(x)[drop.dims],")" ,
                      sep="", collapse=", "),
                "\n")
        }
        
        invisible(x)
    }
}

summary.mcarray <- function(object, FUN, ...)
{
    if (!checkdimtags(object)) {
        NextMethod()
    }
    else {
        collapse(object, keep.tags="value", FUN=FUN, ...)
    }
}

make.coda.names <- function(basename, dim)
{
    if (all(dim == 1)) {
        return(basename)
    }
    else {
        ll <- lapply(as.list(dim), function(n) seq(from=1, to=n))
        elements <- expand.grid(ll)
        elt.names <- apply(elements, 1, paste, collapse=",")
        elt.names <- paste0(basename, "[", elt.names, "]")
        return(elt.names)
    }
}

checkdimtags <- function(x)
{
    tags <- dimtags(x)
    if (is.null(tags)) {
        return (FALSE)
    }
    else if (!all(tags %in% c("value", "iteration", "chain"))) {
        return (FALSE)
    }
    return(TRUE)
}

as.mcmc.list.mcarray <- function(x, na.rm=TRUE, ...)
{
    if (is.null(dim(x)) || !checkdimtags(x)) {
        stop("Cannot convert object without dimtags")
    }

    xdim <- dim(x)
    ndim <- length(xdim)
    tags <- dimtags(x)

    mcp <- attr(x, "mcpar")
    if (is.null(mcp)) {
        start <- thin <- 1
    }
    else {
        start <- mcp[1]
        thin <- mcp[3]
    }
    
    which.val <- which(tags == "value")

    which.iter <- which(tags == "iteration")
    if (length(which.iter) == 0) {
        stop("mcarray has no iteration dimension")
    }
    if (length(which.iter) > 1) {
        stop("Multiple iteration dimensions in mcarray")
    }

    which.chain <- which(tags == "chain")
    if (length(which.chain) > 1) {
        stop("Multiple chain dimensions in mcarray")
    }

    niter <- xdim[which.iter]
    if (length(which.chain) == 0) {
        perm <- c(which.val, which.iter)
        y <- matrix(aperm(x, perm), nrow=niter, byrow=TRUE)
        nvar <- ncol(y)
        ans <- list(mcmc(y, start=start, thin=thin))
    }
    else {
        nchain <- xdim[which.chain]
        ans <- vector("list", nchain)
        len <- prod(xdim[-which.chain])
        nvar <- prod(xdim[which.val])
        perm <- c(which.val, which.iter, which.chain)
        y <- aperm(x,perm)

        for (i in 1:nchain) {
            ans[[i]] <- mcmc(matrix(y[1:len + (i-1)*len], nrow=niter, byrow=TRUE),
                             start=start, thin=thin)
        }
    }
    
    val.names <- NULL
    if (!is.null(attr(x, 'valuenames', exact=TRUE))) {
        ## If valuenames attribute is set then use this
        val.names <- attr(x, 'valuenames')
        if (length(val.names) != nvar){
            stop(paste0('The length of the valuenames attr (', length(val.names), ') does not match the number of variables (', nvar, ')'))
        }
    }
    else {
        ## Set default value names based on the varname attribute, if
        ## set. Ignore it it contains square brackets indicating that
        ## it is already a subset.  Fall back to "x" as a generic
        ## variable name
        varname <- attr(x, "varname", exact=TRUE)
        if (is.null(varname) || grepl("\\[", varname)) {
            varname <- "x"
        }
        val.names <-  make.coda.names(varname, xdim[which.val])
    }
    
    if (!is.null(val.names)) {
        for (i in 1:nchain) {
            colnames(ans[[i]]) <- val.names
        }
    }

    if (isTRUE(na.rm)) {
        ## Drop missing values if required
        all.missing <- sapply(ans, function(x) {apply(is.na(x), 2, all)})
        drop.vars <- if (is.matrix(all.missing)) {
                         apply(all.missing, 1, any)
                     }
                     else {
                         any(all.missing)
                     }
        ans <- lapply(ans, function(x) x[, !drop.vars, drop=FALSE])
    }
    
    return(mcmc.list(ans))
}

#  R package rjags file R/read.data.R
#  Copyright (C) 2009-2011 Martyn Plummer
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License version
#  2 as published by the Free Software Foundation.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  A copy of the GNU General Public License is available at
#  http://www.r-project.org/Licenses/
#

read.data <- function(file, format=c("jags","bugs"))
{
    .Deprecated("read.jagsdata", package="rjags")
    format <- match.arg(format)
    switch(format, "jags"=read.jagsdata(file), "bugs"=read.bugsdata(file))
}

read.jagsdata <- function(file)
{
  e <- new.env()
  eval(parse(file), e)
  return(as.list(e))
}

read.bugsdata <- function(file)
{
    bugs.dat <- dget(file)
    for (n in names(bugs.dat)) {
        if (!is.null(dim(bugs.dat[[n]]))) {
            dim(bugs.dat[[n]]) <- rev(dim(bugs.dat[[n]]))
            bugs.dat[[n]] <- aperm(bugs.dat[[n]])
        }
    }
    return(bugs.dat)
}
    

#  R package rjags file R/windows/progress.bar.R
#  Copyright (C) 2009 Martyn Plummer
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License version
#  2 as published by the Free Software Foundation.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  A copy of the GNU General Public License is available at
#  http://www.r-project.org/Licenses/
#

updatePB <- function(start.iter, end.iter, adapting)
{
    winProgressBar(title=ifelse(adapting, "Adapting","Updating"),
                  label="Iteration 0", min = start.iter, max=end.iter,
                  initial=start.iter)
}

setPB <- function(pb, iter)
{
    setWinProgressBar(pb, iter, label=paste("Iteration",iter))
}

##  R package rjags file R/jags.R
##  Copyright (C) 2006-2024 Martyn Plummer
##
##  This program is free software; you can redistribute it and/or
##  modify it under the terms of the GNU General Public License version
##  2 as published by the Free Software Foundation.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  A copy of the GNU General Public License is available at
##  http://www.r-project.org/Licenses/
##

.quiet.messages <- function(quiet)
{
    .Call("quietMessages", quiet, PACKAGE="rjags")
}

print.jags <- function(x, ...)
{
  cat("JAGS model:\n\n")

  model <- x$model()
  for (i in 1:length(model)) {
    cat(model[i],"\n",sep="")
  }

  data <- x$data()
  full <- !sapply(lapply(data, is.na), any)
  if (any(full)) {
    cat("Fully observed variables:\n", names(data)[full], "\n")
  }
  part <- !full & !sapply(lapply(data, is.na), all)
  if (any(part)) {
    cat("Partially observed variables:\n", names(data)[part], "\n")
  }
}

jags.model <- function(file, data=NULL, inits,
                       n.chains = 1, n.adapt=1000, quiet = FALSE,
                       n.threads = n.chains, initrep=10000)
{
    if (missing(file)) {
        stop("Model file name missing")
    }
    if (is.character(file)) {
      modfile <- file
      ## Check file exists and can be opened in text mode
      con <- try(file(modfile, "rt"))
      if (inherits(con, "try-error")) {
        stop(paste("Cannot open model file \"", modfile, "\"", sep=""))
      }
      close(con)
      ## Need this for print method and for recompile function
      model.code <- readLines(file, warn=FALSE)
    }
    else if (inherits(file, "connection")) {
        modfile <- tempfile()
        ## JAGS library requires a physical file, so we need to copy
        ## the contents of the connection to a temporary file
        model.code <- readLines(file, warn=FALSE)
        writeLines(model.code, modfile)
    }
    else {
        stop("'file' must be a character string or connection")
    }

    if (quiet) {
        .quiet.messages(TRUE)
        on.exit(.quiet.messages(FALSE), add=TRUE)
    }

    p <- .Call("make_console", PACKAGE="rjags")
    .Call("check_model", p, modfile, PACKAGE="rjags")
    if (!is.character(file)) {
        unlink(modfile) #Remove temporary copy
    }

    varnames <- .Call("get_variable_names", p, PACKAGE="rjags")
    if (missing(data) || is.null(data)) {
        data <- list()
    }
    else if (is.environment(data)) {
        ## Get a list of numeric objects from the supplied environment
        data <- mget(varnames, envir=data, mode="numeric",
                     ifnotfound=list(NULL))
        ## Strip null entries
        data <- data[!sapply(data, is.null)]
    }
    else if (is.list(data)) {
        v <- names(data)
        if (is.null(v) && length(data) != 0) {
            stop("data must be a named list")
        }
        if (any(nchar(v)==0)) {
            stop("unnamed variables in data list")
        }
        if (any(duplicated(v))) {
            stop("Duplicated names in data list: ",
                 paste(v[duplicated(v)], collapse=" "))
        }
        relevant.variables <- v %in% varnames
        data <- data[relevant.variables]
        unused.variables <- setdiff(v, varnames)
        for (i in seq(along=unused.variables)) {
            warning("Unused variable \"", unused.variables[i], "\" in data")
        }
        ## Coerce data frames to numeric matrices
        df <- which(as.logical(sapply(data, is.data.frame)))
        for (i in seq(along=df)) {
            if (all(sapply(data[[df[i]]], is.numeric))) {
                data[[df[i]]] <- as.matrix(data[[df[i]]])
            }
            else {
                stop("Data frame with non-numeric elements provided as data: ",
                     names(data)[df[i]])
            }
        }
    }
    else {
        stop("data must be a list or environment")
    }

    ## An entry consisting entirely of NAs is logical, not numeric.
    ## We coerce it to numeric to avoid failing the numeric test below.
    for (i in seq_along(data)) {
        if (all(is.na(data[[i]]))) {
            mode(data[[i]]) <- "numeric"
        }
    }
    
    ## Warn about non-numeric data
    num_vals <- sapply(data, is.numeric)
    if (any(!num_vals)) {
        warning(paste("Non-numeric data values supplied for variable(s) ",
                      paste(names(data)[!num_vals], collapse=", "), sep=""))
    }

    .Call("compile", p, data, as.integer(n.chains), TRUE, PACKAGE="rjags")
    .Call("set_nthread", p, as.integer(n.threads), PACKAGE="rjags")
    
### Setting initial values

    if (!missing(inits) && !is.null(inits))  {

        checkParameters <- function(inits) {
            if(!is.list(inits)) {
                return("inits parameter must be a list")
            }

            inames <- names(inits)
            if (is.null(inames) || any(nchar(inames) == 0)) {
                return("No variable names supplied for the initial values")
            }

            dupinames <- duplicated(inames)
            if (any(dupinames)) {
                return(paste("Duplicated initial values for variable(s): ",
                             paste0(unique(inames[dupinames]), collapse = ", ")
                             )
                       )
            }

            if (any(inames==".RNG.name")) {
                rngname <- inits[[".RNG.name"]]
                if (!is.character(rngname) || length(rngname) != 1) {
                    return("Incorrect .RNG.name value")
                }
                inits[[".RNG.name"]] <- NULL
            }

            ## Strip null initial values, but give a warning
            null.inits <- sapply(inits, is.null)
            if (any(null.inits)) {
                warning(paste("NULL initial value supplied for variable(s) ",
                        paste(inames[null.inits], collapse=", "), sep=""))
                inits <- inits[!null.inits]
            }

            ## Coerce entries consisting entirely of NAs to numeric.
            na.inits <- sapply(inits, function(x) all(is.na(x)))
            for (i in which(na.inits)) {
                mode(inits[[i]]) <- "numeric"
            }

            num_vals <- sapply(inits, is.numeric)
            if (any(!num_vals)) {
                return(paste("Non-numeric initial values supplied for variable(s) ",
                       paste(inames[!num_vals], collapse=", "), sep=""))
            }

            return ("ok")
        }

        setParameters <- function(inits, chain) {
            if (!is.null(inits[[".RNG.name"]])) {
                .Call("set_rng_name", p, inits[[".RNG.name"]],
                      as.integer(chain), PACKAGE="rjags")
                inits[[".RNG.name"]] <- NULL
            }
            .Call("set_parameters", p, inits, as.integer(chain),
                  PACKAGE="rjags")
        }

        init.values <- vector("list", n.chains)

        if (is.function(inits)) {
            if (any(names(formals(inits)) == "chain")) {
                for (i in 1:n.chains) {
                    init.values[[i]] <- inits(chain=i)
                }
            }
            else {
                for (i in 1:n.chains) {
                    init.values[[i]] <- inits()
                }
            }
        }
        else if (is.list(inits)) {

            if ( !is.null(names(inits)) ) {
                ## Replicate initial values for all chains
                for (i in 1:n.chains) {
                    init.values[[i]] <- inits
                }
            }
            else {
                if (length(inits) != n.chains) {
                    stop("Length mismatch between inits and n.chains")
                }
                init.values <- inits
            }
        }

        for (i in 1:n.chains) {
            msg  <- checkParameters(init.values[[i]])
            if (!identical(msg, "ok")) {
                stop("Invalid parameters for chain ", i, ":\n", msg);
            }
            setParameters(init.values[[i]], i)
            unused.inits <- setdiff(names(init.values[[i]]), varnames)
            unused.inits <- setdiff(unused.inits,
                                    c(".RNG.seed", ".RNG.state", ".RNG.name"))
            for (j in seq(along=unused.inits)) {
                warning("Unused initial value for \"", unused.inits[j],
                        "\" in chain ", i)
            }
        }
    }

    initrep <- as.integer(initrep)
    if (length(initrep) == 0 || any(initrep < 0) || any(!is.finite(initrep))) {
        initrep <- 10000
        warning("Ignoring invalid intrep argument")
    }
    if (length(initrep) == 1) {
        nrep1 <- nrep2 <- initrep
    }
    else {
        nrep1 <- as.integer(initrep[1])
        nrep2 <- as.integer(initrep[2])
        if (length(initrep) > 2)
            warning("Using only the first two elements of initrep")
    }
    .Call("initialize3", p, nrep1, nrep2, PACKAGE="rjags")

    model.state <- .Call("get_state", p, PACKAGE="rjags")
    model.data <- .Call("get_data", p, PACKAGE="rjags")
    model <- list("ptr" = function() {p},
                  "data" = function() {model.data},
                  "model" = function() {model.code},
                  "state" = function(internal=FALSE)
                  {
                      if(!internal) {
                          for(i in 1:n.chains) {
                              model.state[[i]][[".RNG.state"]] <- NULL
                              model.state[[i]][[".RNG.name"]] <- NULL
                          }
                      }
                      return(model.state)
                  },
                  "nchain" = function()
                  {
                      .Call("get_nchain", p, PACKAGE="rjags")
                  },
                  "iter" = function()
                  {
                      .Call("get_iter", p, PACKAGE="rjags")
                  },
                  "sync" = function() {

                      model.state <<- .Call("get_state", p, PACKAGE="rjags")
                  },
                  "recompile" = function() {
                      ## Clear the console
                      .Call("clear_console", p, PACKAGE="rjags")
                      p <<- .Call("make_console", PACKAGE="rjags")
                      ## Write the model to a temporary file so we can re-read it
                      mf <- tempfile()
                      writeLines(model.code, mf)
                      .Call("check_model", p, mf, PACKAGE="rjags")
                      unlink(mf)
                      ## Re-compile
                      .Call("compile", p, data, n.chains, FALSE, PACKAGE="rjags")
                      ## Re-initialize
                      if (!is.null(model.state)) {
                          if (length(model.state) != n.chains) {
                              stop("Incorrect number of chains in saved state")
                          }
                          for (i in 1:n.chains) {
                              statei <- model.state[[i]]
                              rng <- statei[[".RNG.name"]]
                              if (!is.null(rng)) {
                                  .Call("set_rng_name", p, rng, i, PACKAGE="rjags")
                                  statei[[".RNG.name"]] <- NULL
                              }
                              .Call("set_parameters", p, statei, i, PACKAGE="rjags")
                          }
                          .Call("initialize", p, PACKAGE="rjags")
                          ## Redo adaptation
                          adapting <- .Call("is_adapting", p, PACKAGE="rjags")
                          if(n.adapt > 0 && adapting) {
                              cat("Adapting\n")
                              .Call("update", p, n.adapt, PACKAGE="rjags")
                              if (!.Call("check_adaptation", p, PACKAGE="rjags")) {
                                  warning("Adaptation incomplete");
                              }
                          }
                          model.state <<- .Call("get_state", p, PACKAGE="rjags")
                      }
                      invisible(NULL)
                  })
    class(model) <- "jags"

    if (n.adapt > 0) {
        pb <- if(quiet) NULL else getOption("jags.pb")
        ok <- adapt(model, n.adapt, end.adaptation=FALSE, progress.bar=pb)
        if (ok) {
            .Call("adapt_off", p, PACKAGE="rjags")
        }
        else {
            warning("Adaptation incomplete")
        }
    }
    return(model)
}

parse.varname <- function(varname) {

  ## Try to parse string of form "a" or "a[n,p:q,r]" where "a" is a
  ## variable name and n,p,q,r are integers

  v <- try(parse(text=varname, n=1), silent=TRUE)
  if (!is.expression(v) || length(v) != 1)
    return(NULL)

  v <- v[[1]]
  if (is.name(v)) {
    ##Full node array requested
    return(list(name=deparse(v)))
  }
  else if (is.call(v) && identical(deparse(v[[1]]), "[") && length(v) > 2) {
    ##Subset requested
    ndim <- length(v) - 2
    lower <- upper <- numeric(ndim)
    if (any(nchar(sapply(v, deparse)) == 0)) {
      ##We have to catch empty indices here or they will cause trouble
      ##below
      return(NULL)
    }
    for (i in 1:ndim) {
      index <- v[[i+2]]
      if (is.numeric(index)) {
        ##Single index
        lower[i] <- upper[i] <- index
      }
      else if (is.call(index) && length(index) == 3 &&
               identical(deparse(index[[1]]), ":") &&
               is.numeric(index[[2]]) && is.numeric(index[[3]]))
        {
          ##Index range
          lower[i] <- index[[2]]
          upper[i] <- index[[3]]
        }
      else return(NULL)
    }
    if (any(upper < lower))
      return (NULL)
    return(list(name = deparse(v[[2]]), lower=lower, upper=upper))
  }
  return(NULL)
}

parse.varnames <- function(varnames)
{
  names <- character(length(varnames))
  lower <- upper <- vector("list", length(varnames))
  ## Reserved names start with an underscore and are not valid variable names in JAGS
  isreserved <- grepl("_([a-zA-Z]+)([a-zA-Z0-9]*)_", varnames)
  for (i in seq(along=varnames)) {
      if (isreserved[i]) {
          names[i] <- varnames[i]
      }
      else {
          y <- parse.varname(varnames[i])
          if (is.null(y)) {
              stop(paste("Invalid variable subset", varnames[i]))
          }
          names[i] <- y$name
          if (!is.null(y$lower)) {
              lower[[i]] <- y$lower
          }
          if (!is.null(y$upper)) {
              upper[[i]] <- y$upper
          }
      }
  }
  return(list(names=names, lower=lower, upper=upper))
}


jags.samples <-
  function(model, variable.names, n.iter, thin=1, stat="value", summary="trace", simplify=2, ...)
{
    if (!inherits(model, "jags"))
        stop("Invalid JAGS model")

    if (!is.character(variable.names) || length(variable.names) == 0)
        stop("'variable.names' must be a character vector")
    if (!is.numeric(n.iter) || length(n.iter) != 1 || n.iter <= 0)
        stop("n.iter must be a positive integer")
    if (!is.numeric(thin) || length(thin) != 1 || thin <= 0)
        stop("'thin' must be a positive integer")
    if (!is.character(stat) || length(stat) == 0)
        stop("'stat' must be a character vector")
    if (!is.character(summary) || length(summary) == 0)
        stop("'summary' must be a character vector")
    if (length(simplify) != 1)
        stop("'simplify' must be a scalar")
    if (!is.logical(simplify) && !is.numeric(simplify)) 
        stop("'simplify' must be numeric or logical")

    ##  Allow vectorisation of arguments stat, summary, and variable.names
    Nmon <- max(length(stat), length(summary), length(variable.names))
    if (Nmon > 1) {
        if (length(stat) == 1)  stat <- rep(stat, Nmon)
        if (length(summary) == 1)  summary <- rep(summary, Nmon)
        if (length(variable.names) == 1) variable.names <- rep(variable.names, Nmon)
    }
    if (length(stat) != length(summary) || length(stat) != length(variable.names))
        stop("non-matching lengths of monitor stat, summary, and variable.names")
    
    ## Catch equivalent var and variance types:
    summary[stat=="variance"] <- "var"
	
    ##  set_monitors must be called for each relevant monitor type
    pn <- parse.varnames(variable.names)
    status <- .Call("set_monitors", model$ptr(), pn$names, pn$lower, pn$upper,
                    as.integer(thin), stat, summary, PACKAGE="rjags")
    if (!any(status)) stop("No valid monitors set")
    
    startiter <- model$iter()
    n.iter <- n.iter - n.iter%%thin
    
    update.jags(model, n.iter, ...)
    
    ##  Retrieve values for each monitor  used
    stats.used <- unique(stat[status])
    val <- vector("list", length(stats.used))
    names(val) <- stats.used
    for (i in seq_along(stats.used)) {
        s <- stats.used[i]
        summary.used <- unique(summary[stat == s & status])
        val[[i]] <- vector("list", length(summary.used))
        names(val[[i]]) <- summary.used
        for (j in seq_along(summary.used)) {
            t <- summary.used[j]
            ans <- .Call("get_monitored_values", model$ptr(), s, t, PACKAGE="rjags")
            for (k in seq(along=ans)) {
                tname <- names(ans)[k]
                curdim <- dim(ans[[k]])
                
                ## Ensure dim and dimnames are correctly set:
                if(is.null(curdim)){
                    curdim <- length(ans[[k]])
                    dim(ans[[k]]) <- curdim
                }
                
                class(ans[[k]]) <- "mcarray"
                attr(ans[[k]], "varname") <- tname
                attr(ans[[k]], "stat") <- s
                attr(ans[[k]], "summary") <- t
                attr(ans[[k]], "iterations") <- c(start=startiter+thin, end=startiter+n.iter, thin=thin)
            }
            val[[i]][[j]] <- ans
        }
    }
    for (i in seq(along=variable.names)) {
        if (status[i]) {
            .Call("clear_monitor", model$ptr(), pn$names[i], pn$lower[[i]],
                  pn$upper[[i]], stat[i], summary[i], PACKAGE="rjags")
        }
    }
    
    ##  Remove any that are empty:
    ##allans <- allans[lapply(allans, length) > 0]

    if (is.logical(simplify)) {
        simplify <- if (simplify) 3 else 0
    }
    if (simplify > 0) {
        ## Recursively simplify the return value up to max depth
        ## determinined by the 'simplify' parameter
        for (i in 1:min(simplify, 3)) {
            if (length(val) == 1) {
                val <- val[[1]]
            }
            else {
                break
            }
        }
    }
    
    return(val)
}

list.samplers <- function(object)
{
    if (!inherits(object, "jags")) {
        stop("not a jags model object")
    }
    .Call("get_samplers", object$ptr(), PACKAGE="rjags")
}

list.factories <- function(type)
{
    type = match.arg(type, c("sampler","monitor","rng"))
    as.data.frame(.Call("get_factories", type, PACKAGE="rjags"))
}

set.factory <- function(name, type, state)
{
    if (!is.character(name) || length(name) != 1)
        stop("invalid name")
    if (!is.character(type) || length(type) != 1)
        stop("invalid name")
    if (length(state) != 1)
        stop("invalid state")

    type <- match.arg(type, c("sampler","rng","monitor"))
    .Call("set_factory_active", name, type, as.logical(state), PACKAGE="rjags")
}

coda.names <- function(basename, dim)
{
    ## Utility function used to get the names of the individual elements
    ## of a node array

    if (prod(dim) == 1)
      return(basename)

    ##Default lower and upper limits
    ndim <- length(dim)
    lower <- rep(1, ndim)
    upper <- dim

    ##If the node name is a subset, we try to parse it to get the
    ##names of its elements. For example, if basename is "A[2:3]"
    ##we want to return names "A[2]", "A[3]" not "A[2:3][1]", "A[2:3][2]".
    pn <- parse.varname(basename)
    if (!is.null(pn) && !is.null(pn$lower) && !is.null(pn$upper)) {
        if (length(pn$lower) == length(pn$upper)) {
            dim2 <- pn$upper - pn$lower + 1
            if (isTRUE(all.equal(dim[dim!=1], dim2[dim2!=1],
                                 check.attributes=FALSE))) {
                basename <- pn$name
                lower <- pn$lower
                upper <- pn$upper
                ndim <- length(dim2)
            }
        }
    }

    indices <- as.character(lower[1]:upper[1])
    if (ndim > 1) {
        for (i in 2:ndim) {
            indices <- outer(indices, lower[i]:upper[i], FUN=paste, sep=",")
        }
    }
    paste(basename,"[",as.vector(indices),"]",sep="")
}

nchain <- function(model)
{
    if (!inherits(model, "jags"))
      stop("Invalid JAGS model object in nchain")

    .Call("get_nchain", model$ptr(), PACKAGE="rjags")
}

nthread <- function(model)
{
    if (!inherits(model, "jags"))
        stop("Invalid JAGS model object in nchain")
    
    .Call("get_nthread", model$ptr(), PACKAGE="rjags")
}

`nthread<-` <- function(model, value)
{
    if (!inherits(model, "jags"))
        stop("Invalid JAGS model object in nthread")

    .Call("set_nthread", model$ptr(), as.integer(value), PACKAGE="rjags")
}

coda.samples <- function(model, variable.names=NULL, n.iter, thin=1,
                         na.rm = TRUE, ...)
{
    start <- model$iter() + thin
    out <- jags.samples(model, variable.names, n.iter, thin, stat="value", summary="trace",
                        simplify=FALSE, ...)$value$trace
    
    ans <- vector("list", nchain(model))
    for (ch in 1:nchain(model)) {
        ans.ch <- vector("list", length(out))

        vnames.ch <- NULL
        for (i in seq(along=out)) {

            varname <- names(out)[[i]]
            d <- dim(out[[i]])
            if (length(d) < 3) {
                stop("Invalid dimensions for sampled output")
            }
            vardim <- d[1:(length(d)-2)]
            nvar <- prod(vardim)
            niter <- d[length(d) - 1]
            nchain <- d[length(d)]

            values <- as.vector(out[[i]])
            var.i <- matrix(NA, nrow=niter, ncol=nvar)
            for (j in 1:nvar) {
                var.i[,j] <- values[j + (0:(niter-1))*nvar + (ch-1)*niter*nvar]
            }
            vnames.ch <- c(vnames.ch, coda.names(varname, vardim))
            ans.ch[[i]] <- var.i
        }

        ans.ch <- do.call("cbind", ans.ch)
        colnames(ans.ch) <- vnames.ch
        ans[[ch]] <- mcmc(ans.ch, start=start, thin=thin)
    }

    if (isTRUE(na.rm)) {
        ## Drop variables that are missing for all iterations in at least
        ## one chain
        all.missing <- sapply(ans, function(x) {apply(is.na(x), 2, any)})
        drop.vars <- if (is.matrix(all.missing)) {
            apply(all.missing, 1, any)
        }
        else {
            any(all.missing)
        }
        ans <- lapply(ans, function(x) return(x[, !drop.vars, drop=FALSE]))
    }

    mcmc.list(ans)
}

load.module <- function(name, path, quiet=FALSE)
{   
    if (name %in% list.modules()) {
        ## This is a stop-gap measure as JAGS 2.1.0 does allow you
        ## to load the same module twice. This should be fixed in
        ## later versions.
        return(invisible()) #Module already loaded
    }

    if (missing(path)) {
        path = getOption("jags.moddir")
        if (is.null(path)) {
            stop("option jags.moddir is not set")
        }
    }
    if (!is.character(path) || length(path) != 1)
        stop("invalid path")
    if (!is.character(name) || length(name) != 1)
        stop("invalid name")

    file <- file.path(path, paste(name, .Platform$dynlib.ext, sep=""))
    if (!file.exists(file)) {
        stop("File not found: ", file)
    }
    if (!isDLLLoaded(file)) {
        ## We must avoid calling dyn.load twice on the same DLL This
        ## may result in the DLL being unloaded and then reloaded,
        ## which will invalidate pointers to the distributions,
        ## functions and factories in the module.
        dyn.load(file)
    }
    ok <- .Call("load_module", name, PACKAGE="rjags")
    if (!ok) {
        stop(paste("module", name, "not found\n"))
    }
    else if (!quiet) {
        message("module ", name, " loaded")
    }
    invisible()
}

unload.module <- function(name, quiet=FALSE)
{   
    if (!is.character(name) || length(name) != 1)
        stop("invalid name")

    ok <- .Call("unload_module", name, PACKAGE="rjags")
    if (!ok) {
        warning(paste("module", name, "not loaded"))
    }
    else if (!quiet) {
        cat("Module", name, "unloaded\n", sep=" ")
    }
    invisible()
}

list.modules <- function()
{
    .Call("get_modules", PACKAGE="rjags");
}

isDLLLoaded <- function(file)
{
    dll.list <- getLoadedDLLs()
    for (i in seq(along=dll.list)) {
        if (dll.list[[i]]["path"][1] == file)
            return(TRUE)
    }
    return(FALSE)
}

parallel.seeds <- function(factory, nchain)
{
    .Call("parallel_seeds", factory, nchain, PACKAGE="rjags")
}

jags.seed <- function(seed) {
    .Call("set_seed", seed, PACKAGE="rjags")
}
    

.check.jags.home <- function(jags.home, major)
{
    ## Check that folder jags.home actually exists and contains the DLL
    ## in the appropriate sub-folder.

    ## Registry entries created by the JAGS instsaller may be invalid
    ## if the user removes JAGS by manually deleting files rather than
    ## using the uninstaller. So this function is used to check that
    ## the installation still exists.

    if (is.null(jags.home)) return(FALSE)
    if (!is.vector(jags.home, mode="character") || length(jags.home) != 1) {
        return(FALSE)
    }
    if (!file_test("-d", jags.home)) return(FALSE)

    bindir <- file.path(jags.home, .Platform$r_arch, "bin")
    jags.dll <- file.path(bindir, paste("libjags-", major,
                                        .Platform$dynlib.ext, sep=""))
    return(file.exists(jags.dll))
}


.findJAGS <- function(hive, major)
{
    ## Returns the registry key corresponding to the latest release of
    ## JAGS-major.x.y, or NULL if no release is found

    ## JAGS installer records JAGS install directory in 32-bit
    ## registry. This will switch to 64-bit registry after we drop
    ## 32-bit support.  So check both (Fix for problem in rjags_4-11).
    regkey <- try(readRegistry("SOFTWARE\\JAGS", hive = hive, maxdepth = 2,
                               view="64-bit"), silent = TRUE)
    if (inherits(regkey, "try-error")) {
        regkey <- try(readRegistry("SOFTWARE\\JAGS", hive = hive, maxdepth = 2,
                                   view="32-bit"), silent = TRUE)
    }
    if (inherits(regkey, "try-error")) {
        return(NULL)
    }

    keynames <- names(regkey)
    keynames <- keynames[grep(paste0("^JAGS-", major, "\\."), keynames)]
    if (length(keynames) == 0) {
        return(NULL)
    }
    else {
        keynames <- rev(keynames) #Search in reverse order of release number
        regkey <- regkey[keynames]
        for (i in seq(along=keynames)) {
            if(.check.jags.home(regkey[[i]][["InstallDir"]], major)) {
                return(regkey[i])
            }
        }
        return(NULL)
    }
}

.noJAGS <- function(major)
{
  paste("Failed to locate any version of JAGS version ", major, "\n\n",
        "The rjags package is just an interface to the JAGS library\n",
        "Make sure you have installed JAGS-", major,
        ".x.y.exe (for any x >=0, y>=0) from\n",
        "http://www.sourceforge.net/projects/mcmc-jags/files\n", sep="")
}

.onLoad <- function(lib, pkg)
{
### First task is to get installation directory of JAGS

    ## Major version of JAGS library should match major version
    ## of the rjags package
    jags.major <- packageVersion(pkg, lib)$major

    ## Try environment variable first
    jags.home <- Sys.getenv("JAGS_HOME")
    if (nchar(jags.home) > 0) {
        if (!.check.jags.home(jags.home, jags.major)) {
            stop("The environment variable JAGS_HOME is set to\n", jags.home,
                 "\nbut no JAGS installation can be found there\n")
        }
    }
    else {
        ## Search the registry. We need to look for both machine-wide and
        ## user-specific installations

        key1 <- .findJAGS("HLM", jags.major)
        key2 <- .findJAGS("HCU", jags.major)

        if (is.null(key1)) {
            if (is.null(key2)) {
                stop(.noJAGS(jags.major))
            }
            else {
                latest <- key2
            }
        }
        else if (is.null(key2) || names(key2) < names(key1)) {
            latest <- key1
        }
        else {
            latest <- key2
        }

        jags.home <- latest[[1]][["InstallDir"]]
    }

### Add the JAGS bin to the windows PATH, if not already present

    path <- Sys.getenv("PATH")
    split.path <- strsplit(path, .Platform$path.sep)$PATH
    bindir <- file.path(jags.home, .Platform$r_arch, "bin")
    if (!any(split.path == bindir)) {
        path <- paste(bindir, path, sep=.Platform$path.sep)
        if (!Sys.setenv("PATH"=path)) {
            stop("Failed to add the rjags bin directory to the PATH:\n",
                 bindir)
        }
    }

### Load the rjags dll
    library.dynam("rjags", pkg, lib)

### Set the module directory, if the option jags.moddir is not already set

    if (is.null(getOption("jags.moddir"))) {
        options("jags.moddir" = file.path(jags.home, .Platform$r_arch,
                "modules"))
    }

### Check that the module directory actually exists
    moddir <- getOption("jags.moddir")
    if (!file.exists(moddir)) {
        stop(moddir, " not found\n\n",
             "rjags is looking for the JAGS modules in\n", moddir,
             "\nbut this folder does not exist\n")
    }
    load.module("basemod", quiet=TRUE)
    load.module("bugs", quiet=TRUE)

### Set progress bar type

    if (is.null(getOption("jags.pb"))) {
        options("jags.pb"="text")
    }
}

.onAttach <- function(lib, pkg)
{
    packageStartupMessage("Linked to JAGS ",
                          .Call("get_version", PACKAGE="rjags"))
    packageStartupMessage("Loaded modules: ",
                          paste(list.modules(), collapse=","))
}


.onUnload <- function(libpath)
{
    library.dynam.unload("rjags", libpath)
}

#  R package rjags file R/dic.R
#  Copyright (C) 2009-2025 Martyn Plummer and Matt Denwood
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License version
#  2 as published by the Free Software Foundation.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  A copy of the GNU General Public License is available at
#  http://www.r-project.org/Licenses/
#

"dic.samples" <- function(model, n.iter, thin=1, type="pD", ...)
{
    if (nchain(model) == 1) {
        stop("2 or more parallel chains required")
    }
    if (!inherits(model, "jags"))
      stop("Invalid JAGS model")
    
    if (!is.numeric(n.iter) || length(n.iter) != 1 || n.iter <= 0)
      stop("n.iter must be a positive integer")

    pdtype <- match.arg(type, c("pD","popt"))
    penalty_stat <- if (pdtype == "pD") {"leverage"} else {"loo_leverage"}

    samples <- jags.samples(model, variable.names="_observed_",
                            stat=c("deviance", penalty_stat),
                            summary="mean",
                            n.iter=n.iter, thin=thin)
    
    deviance <- collapse(samples[["deviance"]][["mean"]][[1]], keep.tags="value", FUN=mean)
    penalty <- collapse(samples[[penalty_stat]][["mean"]][[1]], keep.tags="value", FUN=mean)
    if (pdtype == "popt") {
        penalty <- 2 * penalty
    }
    
    ans <- list("deviance" = deviance,
                "penalty" = penalty,
                "type" = pdtype)
    class(ans) <- "dic"
    return(ans)
}

"print.dic" <- function(x, digits= max(3, getOption("digits") - 3), ...)
{
    deviance <- sum(x$deviance)
    cat("Mean deviance: ", format(deviance, digits=digits), "\n", sep="")
    psum <- sum(x[[2]])
    cat(names(x)[[2]], ": ", format(mean(psum), digits=digits), "\n", sep="")
    cat("Penalized deviance: ", format(deviance + psum, digits=digits), "\n", sep="")
    invisible(x)
}

"-.dic" <- function(e1, e2)
{
    diffdic(e1, e2)
}
            
"diffdic" <- function(dic1,dic2)
{
    if (!identical(dic1$type, dic2$type)) {
        stop("incompatible dic object: different penalty types")
    }
    n1 <- names(dic1$deviance)
    n2 <- names(dic2$deviance)
    if (!identical(n1, n2)) {

        ### Try matching names in lexicographic order
        if(!identical(sort(n1), sort(n2))) {
            stop("incompatible dic objects: variable names differ")
        }
        ### Reset names to order of the first argument
        ord1 <- order(n1)
        ord2 <- order(n2)
        dic2$deviance[ord1] <- dic2$deviance[ord2]
        dic2$penalty[ord1] <- dic2$penalty[ord2]
    }
    delta <- sapply(dic1$deviance, mean) + sapply(dic1$penalty, mean) -
        sapply(dic2$deviance, mean) - sapply(dic2$penalty, mean)
    class(delta) <- "diffdic"
    return(delta)
}

"print.diffdic" <- function(x, ...)
{
    cat("Difference: ", sum(x), "\n", sep="") 
    cat("Sample standard error: ", sqrt(length(x)) * sd(x), "\n", sep="")
    invisible(x)
}

get_flat_monitors <- function(model, stat, summary)
{
    ## Utility function for waic.samples
    ##
    ## Only for use with monitors that do not have an iteration dimesion
    ## and can therefore be represented as a matrix.
    
    if (!is.character(stat) || length(stat) != 1) stop("Invalid stat")
    if (!is.character(summary) || length(summary) != 1) stop("Invalid summary")
    
    mlist <- .Call("get_monitored_values_flat", model$ptr(), stat, summary, PACKAGE="rjags")
    if (!is.matrix(mlist[[1]])) stop("can only combine matrix-valued mcarrays")
    
    out <- do.call(rbind, mlist)

    ## Set dim tags
    tags <- dimtags(mlist[[1]])
    if (!is.null(tags) && length(tags) == 2) {
        dimtags(out) <- tags
    }
    
    ## Set the value names attribute
    vnames <- unlist(lapply(mlist, function(x) attr(x, "valuenames")))
    if (!is.null(vnames) && length(vnames) == nrow(out)) {
        attr(out, "valuenames") <- vnames
    }
    ## Set the stat and summary attributes
    attr(out, "stat") <- stat
    attr(out, "summary") <- summary
    ## Finally set the class
    class(out) <- "mcarray"

    return(out)
}
    
                              
"waic.samples" <-
    function(model, n.iter, thin=1, nodes="_observed_", scale=2*n, trace=FALSE, ...)
{
    if (!inherits(model, "jags"))
        stop("Invalid JAGS model")
    
    if (!is.numeric(n.iter) || length(n.iter) != 1 || n.iter <= 0)
        stop("n.iter must be a positive integer")

    if (!is.logical(trace) || length(trace)!=1)
        stop("trace must be logical of length 1")

    if (is.null(nodes)) {
        pn <- list(names="_observed_", lower=list(NULL), upper=list(NULL))
    }
    else {
        if (!is.character(nodes) || length(nodes) == 0)
            stop("nodes must either be NULL or a character string of length >=1")
        if (any(nodes == "deviance")) {
            stop("variable name 'deviance' cannot be used: pass nodes='_observed_' for all observed stochastic nodes")
        }
        pn <- parse.varnames(nodes)
    }
    nnames <- length(pn$names)
    
    status1 <- .Call("set_monitors", model$ptr(), pn$names, pn$lower, pn$upper, 
                     as.integer(thin), rep("likelihood", nnames), rep("mean", nnames), PACKAGE="rjags")
    if (!all(unlist(status1))) stop("Failed to set a necessary monitor")
    
    status2 <- .Call("set_monitors", model$ptr(), pn$names, pn$lower, pn$upper, 
                     as.integer(thin), rep("loglikelihood", nnames), rep("var", nnames), PACKAGE="rjags")
    if (!all(unlist(status2))) stop("Failed to set a necessary monitor")
    
    if (trace) {
        status3 <- .Call("set_monitors", model$ptr(), pn$names, pn$lower, pn$upper, 
                         as.integer(thin), rep("loglikelihood", nnames), rep("trace", nnames), PACKAGE="rjags")
        if (!all(unlist(status3))) stop("Failed to set the optional trace monitor")
    }
    
    update(model, n.iter = as.integer(n.iter), ...)

    ## Get monitored values
    likelihood_mean <- get_flat_monitors(model, "likelihood", "mean")
    loglikelihood_var <- get_flat_monitors(model, "loglikelihood", "var")
    if(trace){
        loglikelihood_trace <- get_flat_monitors(model, "loglikelihood", "trace")
    }

    ## Clear monitors
    for(i in seq_along(pn$names)){
        .Call("clear_monitor", model$ptr(), pn$names[i], pn$lower[[i]], pn$upper[[i]], "likelihood", "mean", PACKAGE="rjags")
        .Call("clear_monitor", model$ptr(), pn$names[i], pn$lower[[i]], pn$upper[[i]], "loglikelihood", "var", PACKAGE="rjags")
        if (trace) {
            .Call("clear_monitor", model$ptr(), pn$names[i], pn$lower[[i]], pn$upper[[i]], "loglikelihood", "trace", PACKAGE="rjags")
        }
    }

    ## We assume that monitored nodes are conditionally independent, but it is possible
    ## for the user to specify the same node twice
    if (any(duplicated(rownames(likelihood_mean))))
        warning("Duplicate node names found.")

    
    raw <- list("likelihood_mean"=likelihood_mean, "loglikelihood_var"=loglikelihood_var)
    if (trace) {
        raw <- c(raw, list(loglikelihood_trace = loglikelihood_trace))
    }

    ## Calculate sample size n here for lazy evaluation of the default scale parameter
    n <- nrow(likelihood_mean)
    waictable <- waic.table(likelihood_mean, loglikelihood_var, scale)
    ans <- list(waictable=waictable, mcarray=raw)
    class(ans) <- 'JAGSwaic'	
    
    return(ans)
}


waic.table <- function(likelihood_mean, loglikelihood_var, scale){

    nsample <- nrow(likelihood_mean)
    
    training_loss <- scale * apply(-log(likelihood_mean), 2, sum)
    p_waic <- apply(loglikelihood_var, 2, sum)
    waic <- scale * (training_loss + scale * p_waic/nsample)

    result <- rbind(training_loss, p_waic, waic)
    dimnames(result) <- list(c("training_loss", "p_waic", "waic"), paste0('chain', 1:ncol(result)))

    return(result)
}

print.JAGSwaic <- function(x, ...){
    
    print.default(x$waictable, ...)
}

#  R package rjags file R/jags.object.R
#  Copyright (C) 2007-2011 Martyn Plummer
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License version
#  2 as published by the Free Software Foundation.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  A copy of the GNU General Public License is available at
#  http://www.r-project.org/Licenses/
#

update.jags <- function(object, n.iter = 1, by, progress.bar, ...)
{
    if (!is.numeric(n.iter) || n.iter < 1) {
        stop("Invalid n.iter")
    }

    adapting <- .Call("is_adapting", object$ptr(), PACKAGE="rjags")
    on.exit(object$sync())

    if (missing(progress.bar)) {
        progress.bar <- getOption("jags.pb")
    }
    if (!is.null(progress.bar)) {
        match.arg(progress.bar, c("text","gui","none"))
        if (progress.bar=="none")
            progress.bar <- NULL
    }
    
    do.pb <- interactive() && !is.null(progress.bar) && n.iter >= 100
    if (do.pb) {
        start.iter <- object$iter()
        end.iter <- start.iter + n.iter
        pb <- switch(progress.bar,
                     "text" = txtProgressBar(start.iter, end.iter,
                     initial = start.iter, style=3, width=50,
                     char=ifelse(adapting,"+","*")),
                     "gui" = updatePB(start.iter, end.iter, adapting))
    }
    
    ## Set refresh frequency for progress bar
    if (missing(by) || by <= 0) {
        ##In JAGS 3.x.y there is a memory reallocation bug when
        ##monitoring that slows down updates. Drop refresh
        ##frequency to avoid triggering memory reallocations.
        ##by <- min(ceiling(n.iter/50), 100)
        by <- ceiling(n.iter/50)
    }
    else {
        by <- ceiling(by)
    }
    
    ## Do updates
    n <- n.iter
    while (n > 0) {
        .Call("update", object$ptr(), min(n,by), PACKAGE="rjags")
        if (do.pb) {
            switch(progress.bar,
                   "text" = setTxtProgressBar(pb, object$iter()),
                   "gui" =  setPB(pb, object$iter()))
        }
        n <- n - by
    }
    if (do.pb) {
        close(pb)
    }

    invisible(NULL)
}

adapt <- function(object, n.iter, end.adaptation = FALSE, ...)
{
    if(.Call("is_adapting", object$ptr(), PACKAGE="rjags")) {
        if(n.iter > 0)
			update.jags(object, n.iter, ...)
        ok <- .Call("check_adaptation", object$ptr(), PACKAGE="rjags")
        if (end.adaptation) {
            .Call("adapt_off", object$ptr(), PACKAGE="rjags")
        }
        return(ok)

    }
    else {
        return(TRUE)
    }
}

coef.jags <- function(object, chain = 1, ...) {
    if (!is.numeric(chain) || chain < 1 || chain > object$nchain()) {
        stop("Invalid chain")
    }
    object$state(internal=FALSE)[[chain]]
}

variable.names.jags <- function(object, ...) {
    .Call("get_variable_names", object$ptr(), PACKAGE="rjags")
}

#  R package rjags file R/utilities.R
#  Copyright (C) 2006-2018 Martyn Plummer and Matt Denwood
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License version
#  2 as published by the Free Software Foundation.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  A copy of the GNU General Public License is available at
#  http://www.r-project.org/Licenses/
#

# Note: all functions in here are intended to be exported


# Required to check availability of new features but also useful to export:
jags.version <- function(){
    vers <- .Call("get_version", PACKAGE="rjags")
    ## Work around bug introduced by 5.0.0-beta as package name
    vers <- sub("-beta$", "", vers)
    return(numeric_version(vers))	
}

# Not exported yet:
observed.stochastic.nodes <- function(model, dim){
    if (!inherits(model, "jags")) {
        stop("Invalid JAGS model")
    }
    vars <- .Call("get_obs_stoch_names", model$ptr(), PACKAGE="rjags")
    
    ## Currently just a stub unless compiled against JAGS 4.4.0
    ## so it is necessary to also supply dim for now:
    if(identical(vars, "deviance")){
        stopifnot(is.numeric(dim) && length(dim)==1)
        vars <- coda.names("deviance", dim)
    }
    return(vars)
}

node.names <- function(model){
    if (!inherits(model, "jags")) {
        stop("Invalid JAGS model")
    }
    vars <- .Call("get_variable_names", model$ptr(), PACKAGE="rjags")
    return(vars)
}

expand.varname <- function(varname, dimensions=NULL){
	
    if (!is.character(varname) || length(varname) != 1) {
        stop("varnames must be a character of length 1")
    }
	
    ## TODO: implement
    if (is.null(dimensions)){
        ## If dimensions aren't provided then attempt to guess:
        dimensions <- c(1)
    }
    return(coda.names(varname, dimensions))
}

dimtags <- function(x)
{
    tags <- attr(x, "dimtags")
    if (is.null(tags)) {
        ## Back-compatibility: In rjags < 5 dimtags of mcarray objects were stored as the
        ## names attribute of the dim attribute
        tags <- names(dim(x))
        if (any(nchar(tags)==0)) {
            ## Value dimensions were implicitly represented by empty strings
            tags[nchar(tags) == 0] <- "value"
        }
    }
    return(tags)
}

`dimtags<-` <- function(x, value)
{
    if (is.null(dim(x))) {
        stop("Cannot set dimtags for object with no dims")
    }
    else if (length(dim(x)) != length(value)) {
        stop("Length mismatch between dimtags and dims")
    }
    attr(x, "dimtags") <- value
    return(x)
}

collapse <- function(object, drop.tags, keep.tags, FUN, tag.result=FALSE, ...)
{
    if (is.null(dim(object)) || is.null(dimtags(object))) {
        stop("Cannot collapse object without both dim and dimtags attributes")
    }

    tags <- dimtags(object)
    if (length(tags) != length(dim(object))) {
        stop("length mismatch between dimtags and dim")
    }
    
    if (!missing(drop.tags) && !missing(keep.tags)) {
        stop("Only one of the arguments 'drop.tags' or 'keep.tags' can be specified")
    }
    else if (!missing(keep.tags)) {
        keep.dims <- tags %in% keep.tags
    }
    else if (!missing(drop.tags)) {
        keep.dims <- !(tags %in% drop.tags)
    }
    else {
        stop("At least one of 'drop.tags' and 'keep.tags' must be specified")
    }
    
    out <- apply(object, MARGIN=which(keep.dims), FUN=FUN, ...)
    if (tag.result && !is.null(dim(out)) && length(dim(out)) == sum(keep.dims)) {
        dimtags(out) <- tags[keep.dims]
    }
    return(out)
}

\name{control}
\alias{list.factories}
\alias{set.factory}
\title{Advanced control over JAGS}
\description{
  JAGS modules contain factory objects for samplers, monitors, and
  random number generators for a JAGS model.  These functions allow
  fine-grained control over which factories are active.
}
\usage{
list.factories(type)
set.factory(name, type, state)
}
\arguments{
  \item{name}{name of the factory to set}
  \item{type}{type of factory to query or set. Possible values are
    \code{"sampler"}, \code{"monitor"}, or \code{"rng"}}
  \item{state}{a logical. If \code{TRUE} then the factory will be
    active, otherwise the factory will become inactive.}
}
\value{
  \code{list.factories} returns a data frame with two columns, the first
  column shows the names of the factory objects in the currently loaded
  modules, and the second column is a logical vector indicating whether
  the corresponding factory is active or not.

  \code{set.factory} is called to change the future behaviour of factory
  objects. If a factory is set to inactive then it will be skipped.
} 
\note{
  When a module is loaded, all of its factory objects are active. This
  is also true if a module is unloaded and then reloaded.
}
\examples{
list.factories("sampler")
list.factories("monitor")
list.factories("rng")
set.factory("base::Slice", "sampler", FALSE)
list.factories("sampler")
set.factory("base::Slice", "sampler", TRUE)
}
\author{Martyn Plummer} \keyword{models}

\name{dic.samples}
\alias{dic}
\alias{dic.samples}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Generate penalized deviance samples}
\description{
  Function to extract random samples of the penalized deviance from
  a \code{jags} model.
}
\usage{
dic.samples(model, n.iter, thin = 1, type, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{model}{a jags model object}
  \item{n.iter}{number of iterations to monitor}
  \item{thin}{thinning interval for monitors}
  \item{type}{type of penalty to use}
  \item{...}{optional arguments passed to the update method for jags
             model objects}
}
\details{

  The \code{dic.samples} function generates penalized deviance
  statistics for use in model comparison.  The two alternative penalized
  deviance statistics generated by \code{dic.samples} are the deviance
  information criterion (DIC) and the penalized expected deviance.
  These are chosen by giving the values ``pD'' and ``popt'' respectively
  as the \code{type} argument.

  DIC (Spiegelhalter et al 2002) is calculated by adding the ``effective
  number of parameters'' (\code{pD}) to the expected deviance. The
  definition of \code{pD} used by \code{dic.samples} is the one proposed
  by Plummer (2002) and requires two or more parallel chains in the
  model.

  DIC is an approximation to the penalized plug-in deviance, which is
  used when only a point estimate of the parameters is of interest. The
  DIC approximation only holds asymptotically when the effective number
  of parameters is much smaller than the sample size, and the model
  parameters have a normal posterior distribution.

  The penalized expected deviance (Plummer 2008) is calculated by adding
  the optimism (\code{popt}) to the expected deviance.  The \code{popt}
  penalty is at least twice the size of the \code{pD} penalty, and
  penalizes complex models more severely.

}
\value{
  An object of class ``dic''. This is a list containing the following
  elements:
  \item{deviance}{A numeric vector, with one element for each 
    observed stochastic node, containing the mean deviance for that node}
  \item{penalty}{A numeric vector, with one element for each 
    observed stochastic node, containing an estimate of the contribution
    towards the penalty}
  \item{type}{A string identifying the type of penalty: ``pD'' or
    ``popt''}
}
\note{
  The \code{popt} penalty is estimated by importance weighting, and may
  be numerically unstable.  
}  
\author{Martyn Plummer}
\references{
  Spiegelhalter, D., N. Best, B. Carlin, and A. van der Linde (2002),
  Bayesian measures of model complexity and fit (with discussion).
  \emph{Journal of the Royal Statistical Society Series B}
  \bold{64}, 583-639.

  Plummer, M. (2002),
  Discussion of the paper by Spiegelhalter et al.
  \emph{Journal of the Royal Statistical Society Series B}
  \bold{64}, 620.

  Plummer, M. (2008)
  Penalized loss functions for Bayesian model comparison.
  \emph{Biostatistics}
  doi: 10.1093/biostatistics/kxm049
}
\seealso{\code{\link{diffdic}}}
\keyword{models}

\name{waic.samples}
\alias{waic}
\alias{waic.samples}
\title{Generate samples for the Widely Applicable Information Criterion}
\description{
  Function to extract random samples of the Widely Applicable
  Information  Criterion (WAIC) from  a \code{jags} model.
}
\usage{
waic.samples(model, n.iter, thin = 1, nodes="_observed_", scale=2*n, trace=FALSE, ...)
}
\arguments{
  \item{model}{A jags model object.}
  \item{n.iter}{Number of iterations to monitor.}
  \item{thin}{Thinning interval for monitors.}
  \item{nodes}{character vector of variable names containing nodes to be
    monitored. A variable name can be the name of a whole node array,
    e.g. "x", or subset, e.g. "x[2:5,2]". The monitored nodes will be any
    nodes partially or completely contained in the given variable array or
    subset. The default value "_observed_" monitors all observed stochastic nodes.}
  \item{scale}{Scaling factor for WAIC. The default scaling by twice the
    sample size \code{n} gives a WAIC statistic comparable with AIC and DIC.}
  \item{trace}{Logical flag. If TRUE then a trace of the likelihood
    will be returned for each monitored node in addition to the WAIC
    table.}
  \item{...}{optional arguments passed to the update method for jags
             model objects}
}
\value{
  An object of class "JAGSwaic". This is a list containing the following
  elements:
  \item{waic.table}{A matrix with one column for each chain and 3 rows
    \describe{
      \item{training_loss}{The Bayes training loss multiplied by the
	\code{scale} parameter.}
      \item{p_waic}{The WAIC penalty, measuring the dimension of the model}.
      \item{waic}{Penalized version of the Bayes training loss estimating
	the Bayes generalization error.}
    }
  }
  \item{mcarray}{A list of objects of class "mcarray" containing at
    least the following elements
    \describe{
      \item{likelihood_mean}{The posterior mean of the likelihood for each
	node. This is the posterior predictive density evaluated at the
	observed value.}
      \item{loglikelihood_var}{The posterior variance of the likelihood
	for each node. This is the contribution of each node to the WAIC
	penalty \code{p_waic} and can also be considered a measure of
	local influence for each observation (Plummer 2025).}
    }
    Optionally, if \code{trace=TRUE} the list includes
    \describe{
      \item{loglikelihood_trace}{Trace of the log likelihood for each
	monitored node. If there are a large number of nodes this may
	use a lot of memory.}
    }
  }
}
\details{

  The \code{waic.samples} function calculates the Widely Applicable
  Information Criterion (WAIC) (Watanabe 2010), a predictive information
  criterion for model choice based on singular learning theory (Watanabe
  2009).

  Suppose that \eqn{Y_1 \ldots Y_n}{Y[1] ... Y[n]} are exchangeable
  observations that are conditionally independent given parameters
  \eqn{\theta}{theta}. The posterior predictive density \eqn{q(y)}{q(y)}
  is defined as:

  \deqn{
    q(y) = \text{E}_{\theta} \left[p(y \mid \theta) \mid Y \right]
  }{
    q(y) = E [ p(y | theta) | Y ]
  }

  The princple behind WAIC is that model fit should be measured by
  the Bayes generalization error \eqn{BL_g}{BLg}, which is minus the
  expectation of the log predictive density for a new observation
  \eqn{Y_{n+1}}{Y[n+1]}.

  \deqn{
    BL_g = \text{E} \left[ \log q(Y_{n+1}) \right]
  }{
    BLg = - E [ log q(Y[n+1]) ]
  }

  where the expectation is over the true, unknown distribution of
  \eqn{Y_{n+1}}{Y[n+1]}. In practice, this cannot be evaluated but we can
  approximate the Bayes generalization error by replacing the
  expectation with the empirical average over the observed data. This
  gives the Bayes training loss.

  \deqn{
    BL_t = - \frac{1}{n} \sum_{i=1}^n \log \left[ q(Y_i) \right]
  }{
    BLt = - mean( log [q(Y[1:n])] )
  }
  
  The training loss is a biased estimate of the generalization error. It
  systematically under-estimates the generalization error because it
  uses the data twice: once to evaluate the posterior predictive
  distribution and again to evaluate the expectation over the data.

  Watanabe (2009, 2010) showed that the bias of the Bayes training loss
  can be removed asymptotically for large sample size n by adding a
  penalty \eqn{p_W/n}{pW/n} to give the WAIC:

  \deqn{
    \text{WAIC} = BL_t + \frac{p_W}{n}
  }{
    WAIC = BLt + pW/n
  }

  where

  \deqn{
    p_W = \sum_{i=1}^n \text{Var}_{\theta} \left[ \log p\left(Y_i \mid
    \theta \right) \mid Y \right]
  }{
    pW = sum(var [log p(y | theta) | Y])
  }

  The penalty \eqn{p_W}{pW} can be considered a measure of model
  complexity.  In regular models with non-informative priors,
  \eqn{p_W}{pW} reduces to the dimension of the parameters
  \eqn{\theta}{theta}.
  
  It is common practice to use version of WAIC scaled by
  \eqn{2n}{2*n}. This version of WAIC can be written:
  
  \deqn{
    WAIC = - 2 \sum_{i=1}^n \log \left[ q(Y_i) \right] + 2 p_W
  }{
    WAIC = - 2 * sum( log [q(Y[1:n])] ) + 2 * pW
  }
  
  In this form, WAIC is comparable to the Akaike Information Criterion
  (AIC) and the Deviance Information Criterion (Spiegelhalter et al
  2002). Scaling of WAIC is controlled by the \code{scale} parameter.
  
}
\author{Matt Denwood, Martyn Plummer}
\references{
  Plummer, M. (2025) Bayesian measures of leverage and influence.
  \emph{Arxiv}, \url{https://arxiv.org/html/2503.19996}
  
  Spiegelhalter, D., N. Best, B. Carlin, and A. van der Linde (2002),
  Bayesian measures of model complexity and fit (with discussion).
  \emph{Journal of the Royal Statistical Society Series B}
  \bold{64}, 583-639.

  Watanabe, S (2009), Algebraic Geometry and Statistical Learning
  Theory, Cambridge University Press.

  Watanabe, S (2010) Asymptotic Equivalence of Bayes Cross Validation
  and Widely Applicable Information Criterion in Singular Learning
  Theory, Journal of Machine Learning Research, 11, 116, 3571--3594.
}
\seealso{\code{\link{dic.samples}}}
\keyword{models}

\name{coda.samples}
\alias{coda.samples}
\title{Generate posterior samples in mcmc.list format}
\description{
  This is a wrapper function for \code{jags.samples} which sets a trace
  monitor for all requested nodes, updates the model, and coerces the
  output to a single \code{mcmc.list} object.
}
\usage{
coda.samples(model, variable.names, n.iter, thin = 1, na.rm=TRUE, ...)
}
\arguments{
  \item{model}{a jags model object}
  \item{variable.names}{a character vector giving the names of variables
    to be monitored}
  \item{n.iter}{number of iterations to monitor}
  \item{thin}{thinning interval for monitors}
  \item{na.rm}{logical flag that indicates whether variables
    containing missing values should be omitted. See details.}
  \item{...}{optional arguments that are passed to the update method
             for jags model objects}
}
\value{
  An \code{mcmc.list} object.
}
\details{
  If \code{na.rm=TRUE} (the default) then elements of a variable that
  are missing (\code{NA}) for any iteration in at least one chain will
  be dropped.

  This argument was added to handle incompletely defined variables.
  From JAGS version 4.0.0, users may monitor variables that are not
  completely defined in the BUGS language description of the model,
  e.g. if \code{y[i]} is defined in a \code{for} loop starting from
  \code{i=3} then \code{y[1], y[2]} are not defined. The user may still
  monitor variable \code{y} and the monitored values corresponding to
  \code{y[1], y[2]} will have value \code{NA} for all iterations in all
  chains. Most of the functions in the \pkg{coda} package cannot handle
  missing values so these variables are dropped by default.
}
\examples{
data(LINE)
LINE$recompile()
LINE.out <- coda.samples(LINE, c("alpha","beta","sigma"), n.iter=1000)
summary(LINE.out)
}
\author{Martyn Plummer}
\seealso{\code{\link{jags.samples}}}
\keyword{models}

\name{jags.module}
\alias{load.module}
\alias{unload.module}
\alias{list.modules}
\title{Dynamically load JAGS modules}
\description{
  A JAGS module is a dynamically loaded library that extends the
  functionality of JAGS. These functions load and unload JAGS modules
  and show the names of the currently loaded modules.
}
\usage{
load.module(name, path, quiet=FALSE)
unload.module(name, quiet=FALSE)
list.modules()
}
\arguments{
  \item{name}{name of the load module to be loaded}
  \item{path}{file path to the location of the DLL. If omitted,
    the option \code{jags.moddir} is used to locate the modules}
  \item{quiet}{a logical. If \code{TRUE}, no message will be printed
    about loading the package}
}
\examples{
list.modules()
load.module("glm")
list.modules()
unload.module("glm")
list.modules()
}
\author{Martyn Plummer}
\keyword{interface}

\name{rjags-deprecated}
\alias{rjags-deprecated}
\alias{read.data}
\title{Deprecated Functions in the rjags package}
\description{
  These functions are provided for compatibility with older versions of
  the rjags package and will soon be defunct.
}
\usage{
read.data(file, format=c("jags","bugs"))
}
\arguments{
  \item{file}{name of a file containing a text repesentation of the
    data for a jags model}
  \item{format}{format of the data}
}
\details{
  
  \code{read.data} with \code{format="jags"} is a deprecated synonym for
  \code{\link{read.jagsdata}} and with
  \code{format="bugs"} is a deprecated synonym for
  \code{\link{read.bugsdata}}.

}
\keyword{misc}

\name{parallel}
\alias{parallel.seeds}
\title{Get initial values for parallel RNGs}
\description{
  On a multi-processor system, you may wish to run parallel chains using
  multiple \code{jags.model} objects, each running a single chain on a
  separate processor.  This function returns a list of values that may
  be used to initialize the random number generator of each chain.

}
\usage{
parallel.seeds(factory, nchain)
}
\arguments{
  \item{factory}{Name of the RNG factory to use.}
  \item{nchain}{Number of chains for which to initialize RNGs.}
}
\value{
  \code{parallel.seeds} returns a list of RNG states. Each element
  is a list of length 2 with the following elements:
  \item{.RNG.name}{The name of the RNG}
  \item{.RNG.state}{An integer vector giving the state of the RNG.}
}
\note{
  It is not yet possible to make the results of \code{parallel.seeds}
  reproducible.  This will be fixed in a future version of JAGS.
}
\examples{
##The BaseRNG factory generates up to four distinct types of RNG. If
##more than 4 chains are requested, it will recycle the RNG types, but
##use different initial values
parallel.seeds("base::BaseRNG", 3)

## The lecuyer module provides the RngStream factory, which allows large
## numbers of independent parallel RNGs to be generated. 
load.module("lecuyer")
list.factories(type="rng")
parallel.seeds("lecuyer::RngStream", 5);
}
\author{Martyn Plummer}
\seealso{
  \code{\link{jags.model}}, section \dQuote{Random number generators},
  for further details on RNG initialization;
  \code{\link{list.factories}} to find the names of available RNG
  factories.
}
\keyword{models}

\name{update}
\alias{update.jags}
\title{Update jags models}
\description{
  Update the Markov chain associated with the model. 
}
\usage{
\method{update}{jags}(object, n.iter=1, by, progress.bar, \ldots)
}
\arguments{
  \item{object}{a \code{jags} model object}
  \item{n.iter}{number of iterations of the Markov chain to run}
  \item{by}{refresh frequency for progress bar.  See Details}
  \item{progress.bar}{type of progress bar. Possible values are
    \code{"text"}, \code{"gui"}, and \code{"none"}. See Details.}
  \item{\ldots}{additional arguments to the update method (ignored)}
}
\value{
  The \code{update} method for \code{jags} model objects modifies the
  original object and returns \code{NULL}.
}
\details{

  Since MCMC calculations are typically long, a progress bar is
  displayed during the call to \code{update}.  The type of progress bar
  is determined by the \code{progress.bar} argument.  Type \code{"text"}
  is displayed on the R console. Type \code{"gui"} is a graphical
  progress bar in a new window.  The progress bar is suppressed if
  \code{progress.bar} is \code{"none"} or \code{NULL}, if the update is
  less than 100 iterations, or if R is not running interactively.
  
  The default progress bar type is taken from the option \code{jags.pb}.

  The progress bar is refreshed every \code{by} iterations. The
  update can only be interrupted when the progress bar is refreshed.
  Therefore it is advisable not to set \code{by} to a very large
  value. By default \code{by} is either \code{n.iter/50} or \code{100},
  whichever is smaller.
}
\author{Martyn Plummer}
\keyword{models}

\name{diffdic}
\alias{diffdic}
\title{Differences in penalized deviance}
\description{
  Compare two models by the difference of two \code{dic} objects.
}
\usage{
\special{dic1 - dic2}
diffdic(dic1, dic2)
} 
\arguments{
  \item{dic1, dic2}{Objects inheriting from class ``dic''}
}
\details{
  A \code{diffdic} object represents the difference in penalized
  deviance between two models. A negative value indicates that
  \code{dic1} is preferred and vice versa.
}
\value{
  An object of class ``diffdic''. This is a numeric vector with
  an element for each observed stochastic node in the model.

  The \code{diffdic} class has its own print method, which will
  display the sum of the differences, and its sample standard
  deviation.
}
\note{
  The problem of determining what is a noteworthy difference
  in DIC (or other penalized deviance) between two models is
  currently unsolved.  Following the results of Ripley (1996) on
  the Akaike Information Criterion, Plummer (2008) argues that 
  there is no absolute scale for comparison of two penalized
  deviance statistics, and proposes that the difference should
  be calibrated with respect to the sample standard deviation
  of the individual contributions from each observed stochastic
  node.
}
\author{Martyn Plummer}
\references{
  Ripley, B. (1996)
  \emph{Statistical Pattern Recognition and Neural Networks.} 
  Cambridge University Press.

  Plummer, M. (2008)
  Penalized loss functions for Bayesian model comparison.
  \emph{Biostatistics}
  doi: 10.1093/biostatistics/kxm049
}
\seealso{\code{\link{dic}}}
\keyword{models}

\name{jags.model}
\alias{jags.model}
\title{Create a JAGS model object}
\description{
  \code{jags.model} is used to create an object representing a
  Bayesian graphical model, specified with a BUGS-language description
  of the prior distribution, and a set of data.
}
\usage{
 jags.model(file, data, inits,
            n.chains = 1, n.adapt=1000, quiet=FALSE)
}
\arguments{
  \item{file}{the name of the file containing a description of the model in the
    JAGS dialect of the BUGS language.

    Alternatively, \code{file} can be a readable text-mode connection,
    or a complete URL.}
  \item{data}{a list or environment containing the data. Any numeric
    objects in \code{data} corresponding to node arrays used in
    \code{file} are taken to represent the values of observed nodes
    in the model.}
  \item{inits}{optional specification of initial values in the form of a
    list or a function (see \code{Initialization} below). If omitted,
    initial values will be generated automatically.  It is an error to
    supply an initial value for an observed node.}
  \item{n.chains}{the number of parallel chains for the model}
  \item{n.adapt}{the number of iterations for adaptation. See 
    \code{\link{adapt}} for details. If \code{n.adapt = 0} then no 
    adaptation takes place.}
  \item{quiet}{if \code{TRUE} then messages generated during compilation
    will be suppressed, as well as the progress bar during adaptation.}
}
\value{
  \code{jags.model} returns an object inheriting from class \code{jags}
  which can be used to generate dependent samples from the posterior
  distribution of the parameters
  
  An object of class \code{jags} is a list of functions that share a
  common environment. This environment encapsulates the state of the
  model, and the functions can be used to query or modify the model
  state.
  \item{ptr()}{Returns an external pointer to an object created by
    the JAGS library}
  \item{data()}{Returns a list containing the data that define
    the observed nodes in the model}
  \item{model()}{Returns a character vector containing the BUGS-language
    representation of the model}
  \item{state(internal=FALSE)}{Returns a list of length equal to the
    number of parallel chains in the model. Each element of the list is
    itself a list containing the current parameter values in that chain.
    if \code{internal=TRUE} then the returned lists also include the RNG
    names (\code{.RNG.name}) and states (\code{.RNG.state}).  This is
    not the user-level interface: use the \code{\link{coef.jags}} method
    instead.}
  \item{update(n.iter)}{Updates the model by \code{n.iter} iterations.
    This is not the user-level interface: use the
    \code{\link{update.jags}} method instead.}
}
\section{Initialization}{

  There are various ways to specify initial values for a JAGS model.
  If no initial values are supplied, then they will be generated
  automatically by JAGS. See the JAGS User Manual for
  details. Otherwise, the options are as follows:
  \enumerate{
    \item A list of numeric values. Initial values for a single chain
    may supplied as a named list of numeric values. If there are multiple
    parallel chains then the same list is re-used for each chain.
    
    \item A list of lists. Distinct initial values for each chain may be
    given as a list of lists. In this case, the list should have the same
    length as the number of chains in the model.
    
    \item A function.  A function may be supplied that returns a list of
    initial values.  The function is called repeatedly to generate initial
    values for each chain. Normally this function should call some random
    number generating functions so that it returns different values every
    time it is called. The function should either have no arguments, or
    have a single argument named \code{chain}. In the latter case, the
    supplied function is called with the chain number as argument. In this
    way, initial values may be generated that depend systematically on
    the chain number.
  }
}

\section{Random number generators}{

  Each chain in a model has its own random number generator (RNG).  RNGs
  and their initial seed values are assigned automatically when the
  model is created. The automatic seeds are calculated from the current
  time.

  If you wish to make the output from the model reproducible, you may
  specify the RNGs to be used for each chain, and their starting seeds
  as part of the \code{inits} argument (see \code{Initialization}
  above). This is done by supplementing the list of initial parameter
  values for a given chain with two additional elements named
  \dQuote{.RNG.name}, and \dQuote{.RNG.seed}:
  \describe{
    \item{\code{.RNG.name}}{a character vector of length 1. The names of
    the RNGs supplied in the base module are:
    \itemize{
      \item \dQuote{base::Wichmann-Hill}
      \item \dQuote{base::Marsaglia-Multicarry}
      \item \dQuote{base::Super-Duper}
      \item \dQuote{base::Mersenne-Twister}
    }
    If the lecuyer module is loaded, it provides \dQuote{lecuyer::RngStream}
    }
    \item{\code{.RNG.seed}}{a numeric vector of length 1 containing an
    integer value.}
  }
  
  Note that it is also possible to specify \dQuote{.RNG.state} rather than 
  \dQuote{.RNG.seed} - see for example the output of \code{\link{parallel.seeds}}
}
\author{Martyn Plummer}
\keyword{models}

\name{nthread}
\alias{nthread}
\alias{nthread<-}
\title{Get and set number of threads used by a JAGS model}

\usage{
nthread(model)
nthread(model) <- value
}

\arguments{
\item{model}{a \code{jags} model object}
\item{value}{A positive integer}
}

\value{
   A scalar integer, or NULL.
}

\description{
  \code{nthread()} returns the number of parallel threads used by
  a JAGS model.
}

\seealso{
   \code{\link{jags.model}},
}
\keyword{manip}

\name{rjags-package}
\alias{rjags-package}
\alias{rjags}
\docType{package}
\title{
Bayesian graphical models using MCMC
}
\description{

  The rjags package provides an interface from R to the JAGS library for
  Bayesian data analysis.  JAGS uses Markov Chain Monte Carlo (MCMC) to
  generate a sequence of dependent samples from the posterior
  distribution of the parameters.

}
\details{

  JAGS is a clone of BUGS (Bayesian analysis Using Gibbs Sampling).  See
  Lunn et al (2009) for a history of the BUGS project.  Note that the
  rjags package does not include a copy of the JAGS library: you must
  install this separately. For instructions on downloading JAGS, see the
  home page at \url{https://mcmc-jags.sourceforge.io}.
  
  To fully understand how JAGS works, you need to read the
  \href{https://sourceforge.net/projects/mcmc-jags/files/Manuals/4.x/jags_user_manual.pdf/download}{JAGS
    User Manual}.  The manual explains the basics of modelling with JAGS
  and shows the functions and distributions available in the dialect of
  the BUGS language used by JAGS. It also describes the command line
  interface.  The \pkg{rjags} package does not use the command line
  interface but provides equivalent functionality using R functions.
  
  Analysis using the \pkg{rjags} package proceeds in steps:
  \enumerate{

    \item Define the model using the BUGS language in a separate file.

    \item Read in the model file using the \code{jags.model} function.
    This creates an object of class \dQuote{jags}.

    \item Update the model using the \code{update} method for
    \dQuote{jags} objects.  This constitutes a \sQuote{burn-in} period.

    \item Extract samples from the model object using the
    \code{coda.samples} function. This creates an object of class
    \dQuote{mcmc.list} which can be used to summarize the posterior
    distribution. The \pkg{coda} package also provides convergence
    diagnostics to check that the output is valid for analysis (see
    Plummer et al 2006).

  }
}
\author{
Martyn Plummer
}
\references{
Lunn D, Spiegelhalter D, Thomas A, Best N. (2009) The BUGS project:
Evolution, critique and future directions.  \emph{Statistics in Medicine}, 
\bold{28}:3049-67.

Plummer M, Best N, Cowles K, Vines K (2006). CODA: Convergence Diagnosis
and Output Analysis for MCMC, \emph{R News}, \bold{6}:7-11.

}
\keyword{ package }
%\examples{
%
%}

\name{jags.samples}
\alias{jags.samples}
\title{Generate posterior samples}
\description{
  Function to extract random samples from the posterior distribution
  of the parameters of a \code{jags} model. 
}
\usage{
jags.samples(model, variable.names, n.iter, thin = 1,
             stat="value", summary = "trace", simplify=2, ...)
}
\arguments{

  \item{model}{A jags model object}
  \item{variable.names}{A character vector giving the names of variables
    to be monitored}
  \item{n.iter}{number of iterations to monitor}
  \item{thin}{thinning interval for monitors}
  \item{stat}{character vector of statistics to be monitored}
  \item{summary}{character vector of summaries}
  \item{simplify}{scalar integer or logical flag that determines whether
    the return value will be simplified. See Value below.}
  \item{...}{optional arguments passed to the update method for jags
    model objects}

}
\details{

  The \code{jags.samples} function creates monitors for the given
  variables, runs the model for \code{n.iter} iterations and returns
  the monitored samples.

}
\value{

  A nested list of \code{mcarray} objects is returned.  The top level
  denotes the requested stat, the second level the summary, and the
  third level the monitored variable. Individual \code{mcarray} objects
  can be extrected with \code{samples$stat$summary$variable}
  substituting appropriate names for \code{stat}, \code{summary}, and
  \code{variable}, e.g. \code{samples$value$trace$alpha}.

  In mathematical terms, the return value is a tree with \code{mcarray}
  objects as leaf nodes. If the root node of the tree is unary, i.e. it
  has only one child node, then we can simplify the return value by
  returning the next level of the tree. This is controlled by the
  \code{simplify} parameter. If \code{simplify} is an integer between 1
  and 3 then it determines the maximum depth of the simplification. A
  value of 0 indicates no simplification. For backward compatibility
  with JAGS 4, the default value is \code{simplify=2} meaning that
  levels corresponding to \code{stat} and \code{summary} will be
  simplified, if they are unary, but not \code{value}.

  The \code{simplify} parameter may also be a logical flag where
  \code{FALSE} means no simplification and \code{TRUE} is equivalent to
  \code{simplify=3}.  This is most useful when only a single
  stat/summary/variable combination is monitored, in which case a single
  \code{mcarray} object is returned instead of a nested list.

}
\examples{
  data(LINE)
  LINE$recompile()
  ## With simplify=FALSE the output is a nested list of depth 3
  LINE.samples <- jags.samples(LINE, c("alpha","beta","sigma"),
                               n.iter=1000, simplify=FALSE)
  ## Access the value trace monitor for node alpha
  LINE.samples$value$trace$alpha

  ## With simplify=2, the top 2 levels of the list are removed
  ## because all monitors are of stat type "value" and summary type "trace"
  LINE.samples <- jags.samples(LINE, c("alpha","beta","sigma"),
                               n.iter=1000, simplify=2)
  ## Simpler access to the value trace monitor for alpha
  LINE.samples$alpha

  ## If we have monitors of the same stat type but different summary
  ## types then simplify will only remove the top level of the list,
  ## even if we request maximum simplification
  LINE.samples <- jags.samples(LINE, "alpha",  n.iter=1000,
                               summary=c("mean","var"),
                               simplify=3)
  LINE.samples$mean$alpha
}
\author{Martyn Plummer}
\seealso{\code{\link{jags.model}}, \code{\link{coda.samples}}}
\keyword{models}

\name{jags.object}
\alias{variable.names.jags}
\alias{coef.jags}
\alias{list.samplers}
\title{Functions for manipulating jags model objects}
\description{
  A \code{jags} object represents a Bayesian graphical model
  described using the BUGS language. 
}
\usage{
\method{coef}{jags}(object, chain=1, \ldots)
\method{variable.names}{jags}(object, \ldots)
list.samplers(object)
}
\arguments{
  \item{object}{a \code{jags} model object}
  \item{chain}{chain number to query}
  \item{\ldots}{additional arguments to the call (ignored)}
}
\value{
  The \code{coef} function returns a list with an entry for each Node
  array that contains an unobserved Node. Elements corresponding to
  observed Nodes or deterministic Nodes are given missing values.

  The \code{variable.names} function returns a character vector of
  names of node arrays used in the model.

  The \code{list.samplers} function returns a named list with an entry
  for each Sampler used by the model.  Each list element is a character
  vector containing the names of stochastic Nodes that are updated
  together in a block. The names of the list elements indicate the
  sampling methods that are used to update each block.  Stochastic nodes
  that are updated by forward sampling from the prior are not listed.

} 
\examples{
  data(LINE)
  LINE$recompile()
  coef(LINE)
  variable.names(LINE)
  list.samplers(LINE)
}
\author{Martyn Plummer} \keyword{models}

\name{jags.seed}
\alias{jags.seed}
\title{Set initial value for JAGS RNGs}
\description{
  Sets the random seed used by JAGS.
}
\usage{
jags.seed(seed)
}
\arguments{
  \item{seed}{A single integer value.}
}
\details{
  This function sets the seed for the pseudo-random number generators
  (RNGs) used by JAGS making subsequent simulations reproducible.

  Once the random seed is set by \code{jags.seed}, the same seed will be
  applied to RNG factories in subsequently loaded modules. In practical
  terms this means that a call to \code{jags.seed} may come before or
  after a call to \code{load.module} and will have the same effect.
}
\note{
  The JAGS RNGs are independent of the RNGs used by R. A call to the
  base function \code{set.seed} has no effect on the RNGs used by
  JAGS, and vice versa.
}
\author{Martyn Plummer}
\seealso{
  \code{\link{list.factories}} to find the names of available RNG
  factories.
}
\keyword{models}

\name{line}
\docType{data}
\alias{LINE}

\title{Linear regression example}
\description{
The LINE model is a trivial linear regression model with only 5 observations.
It's main use is to allow automated checks of the \pkg{rjags} package.
}
\format{
  A \code{jags.model} object, which must be recompiled before
  use.
}
\keyword{datasets}

\name{read.jagsdata}
\alias{read.jagsdata}
\alias{read.bugsdata}
\title{Read data files for jags models}
\description{
  Read data for a JAGS model from a file.
}
\usage{
read.jagsdata(file)
read.bugsdata(file)
}
\arguments{
  \item{file}{name of a file containing a text repesentation of the
    data for a jags model}
}
\value{
  A named list of numeric vectors or arrays. 
}
\details{
  
  The command line interface for JAGS reads data and initial values from
  a text file.  The data format used for jags data files is the same as the R
  \code{dump} function. Thus the data values can be read into an
  R session using the \code{source} function, but this will create
  objects in the global environment. The \code{read.jagsdata} function
  is a simple wrapper that reads the data into a list instead.

  OpenBUGS also reads data and initial values from a text file. The
  format of these files is described as "S-PLUS" format by the OpenBUGS
  authors. It superficially resembles the format used by the \code{dput}
  function (and in fact can be parsed by the \code{dget}
  function). However, in BUGS "S-PLUS" format, arrays are stored in
  row-major order instead of the column-major order used by R.  The
  \code{read.bugsdata} function reads OpenBUGS "S-PLUS" format files and
  permutes the elements of arrays so that they appear in the correct
  order.

  Either function returns a list which can be used as the
  \code{data} or \code{inits} argument of \code{jags.model}.

}
\note{
  Earlier versions of the rjags package had a \code{read.data} function
  which read data in either format, but the function name was ambiguous
  (There are many data file format in R) so this is now deprecated.
}
\author{Martyn Plummer}
\keyword{file}

\name{collapse}
\alias{collapse}
\title{Collapse tagged arrays}
\description{
  Interface to the apply function for tagged arrays
}
\usage{
  collapse(object, drop.tags, keep.tags, FUN, tag.result=FALSE, ...)
}
\arguments{
  \item{object}{An array with a dimtags attribute}
  \item{drop.tags}{tags of dimensions to be dropped}
  \item{keep.tags}{tags of dimensions to be preserved}
  \item{FUN}{the function to be applied}
  \item{tag.result}{binary indicator. If TRUE then the result will also
    be a tagged array if possible}
  \item{...}{additional arguments passed to FUN}
}
\details{
  
  Using the \code{apply} function to simplify high-dimensional arrays
  can be complicated. This function provides a simplified interface for
  tagged arrays with two advantages over the basic \code{apply} function:

  \enumerate{
    \item{Dimensions are referred to by name (dimtags), not by number.}
    \item{The user can define ether the dimensions to be kept or the
      dimensions to be dropped (but not both).}
  }

}
\value{
  Usually the output is a lower-dimensional array (vector, matrix, or
  array). If the output cannot be simplified because \code{FUN} returns
  values of varying length, the output will be a list.

  If \code{tag.result=TRUE}, then the \code{collapse} function will add
  dimtags to the result if it can. This is generally only possible if
  \code{FUN} returns a scalar and the output is not a vector (which has
  no \code{dim} attribute).

  Tagging the result allows a further call to the \code{collapse}
  function. For example, if MCMC output is represented as a tagged
  array, we may wish to calculate the posterior mean within each chain,
  and then the variance of the means between chains.

}
\author{Martyn Plummer}
\seealso{\code{\link{dimtags}}, \code{\link{apply}}}
\keyword{manip}

\name{jags.version}
\alias{jags.version}
\title{Get JAGS version}
\description{
  Function to find the version of the \code{JAGS} library linked to the
  \code{rjags} package.
}
\usage{
jags.version()
}
\details{
  The \code{rjags} package links to the \code{JAGS} library when loaded.
  This function returns the version of the linked \code{JAGS} library.

  In principle, the major version of the \code{rjags} package should
  match major version of \code{JAGS}.  The \code{jags.version()}
  function also returns information on the minor version and release
  number of \code{JAGS}.
}
\value{
  An object of class \code{"numeric_version"}.
}
\examples{
  jags.version()
}
\author{Matt Denwood}
\seealso{numeric_version}
\keyword{utilities}

\name{adapt}
\alias{adapt}
\title{Adaptive phase for JAGS models}
\description{
  Update the model in adaptive mode.
}
\usage{
adapt(object, n.iter, end.adaptation=FALSE, \ldots)
}
\arguments{
  \item{object}{a \code{jags} model object}
  \item{n.iter}{length of the adaptive phase}
  \item{end.adaptation}{logical flag. If \code{TRUE} then adaptive
    mode will be turned off on exit.}
  \item{\ldots}{additional arguments to the update method}
}
\value{
  Returns \code{TRUE} if all the samplers in the model have successfully
  adapted their behaviour to optimum performance and \code{FALSE}
  otherwise.
}
\details{

  This function is not normally called by the user.  It is called by the
  \code{jags.model} function when the model object is created.

  When a JAGS model is compiled, it may require an initial sampling
  phase during which the samplers adapt their behaviour to maximize
  their efficiency (e.g. a Metropolis-Hastings random walk algorithm may
  change its step size).  The sequence of samples generated during this
  adaptive phase is not a Markov chain, and therefore may not be used
  for posterior inference on the model.

  The \code{adapt} function updates the model for \code{n.iter}
  iterations in adaptive mode. Then each sampler reports whether it
  has acheived optimal performance (e.g. whether the rejection rate of a
  Metropolis-Hasting sampler is close to the theoretical optimum). If
  any sampler reports failure of this test then \code{adapt} returns
  \code{FALSE}.

  If \code{end.adaptation = TRUE}, then adaptive mode is turned off on
  exit, and further calls to \code{adapt()} do nothing. The model may be
  maintained in adaptive mode with the default option \code{end.adaptation =
  FALSE} so that successive calls to \code{adapt()} may be made until
  adaptation is satisfactory.

}
\author{Martyn Plummer}
\keyword{models}

\name{dimtags}
\alias{dimtags}
\alias{dimtags<-}
\title{Get and set dimtags for a tagged array}

\usage{
dimtags(x)
dimtags(x) <- value
}

\arguments{
  \item{x}{A matrix, array, or any object with a  \code{dim} attribute}
  \item{value}{A character vector of tags, which must match the number
    of dimensions}
}

\value{

  A character vector of dimtags. The replacement function returns the
  modified array.

}

\description{

  Dimtags are designed to make working with high-dimensional arrays
  simpler by providing names for each dimension. We use the word "tags"
  instead of names for two reasons
  \enumerate{
    \item{To avoid confusion with dimnames which already exists and
      means something different}
    \item{Because more than dimension can have the same tag. So tags
      do not uniquely identify each dimension}
  }

  This infrastructure was put in place to support objects of class
  \code{mcarray}, which are tagged arrays with some additional
  attributes. The primary use of tagging is to simplify the manipulation
  of high-dimensional arrays using the \code{collapse} function instead
  of \code{apply}.
  
}

\seealso{
   \code{\link{collapse}}, \code{\link{mcarray.object}},
}
\keyword{manip}

\name{mcarray.object}
\alias{mcarray.object}
\alias{print.mcarray}
\alias{summary.mcarray}
\alias{as.mcmc.list.mcarray}
\title{Objects for representing MCMC output}
\description{
  An \code{mcarray} object is used by the \code{jags.samples} function
  to represent monitored output from a JAGS model. It is a tagged array with
  tags "value", "iteration" and "chain".
}
\usage{
\method{summary}{mcarray}(object, FUN, \ldots)
\method{print}{mcarray}(x, \ldots)
\method{as.mcmc.list}{mcarray}(x, na.rm=TRUE, \ldots)
}
\arguments{
  \item{object,x}{an \code{mcarray} object}
  \item{FUN}{a function to be used to generate summary statistics}
  \item{na.rm}{indicates whether elements with missing values should be removed}
  \item{\ldots}{additional arguments to the call}
}
\value{
  The \code{summary} method for \code{mcarray} objects collapses
  the object over "chain" and "iteration" dimensions leaving "value"
  dimensions.

  The \code{print} method prints the mean, collapsing over
  "chain" and "iteration" dimensions. It also includes information
  about the "stat" and "summary" of the JAGS monitor and the size
  of the collapsed dimensions.

  The \code{as.mcmc.list} method coerces an \code{mcarray} to an
  \code{mcmc.list} object so that the diagnostics provided by the
  \code{coda} package can be applied to the MCMC output it represents.
}
\details{
  The \code{coda} package defines \code{mcmc} objects for representing
  output from an MCMC sampler, and \code{mcmc.list} for representing
  output from multiple parallel chains.  These objects emphasize the
  time-series aspect of the MCMC output, but lose the original array
  structure of the variables they represent.  The \code{mcarray} class
  attempts to rectify this by preserving the dimensions of the original
  node array defined in the JAGS model.

  Objects of class \code{mcarray} are tagged arrays with a limited
  set of supported tags:
  \describe{
    \item{"value"}{dimensions corresponding to the dimension of the object
      in the JAGS model}
    \item{"iteration"}{dimension corresponding to the evolution of the
      Markov chain over iterations}
    \item{"chain"}{dimension corresponding to replication of the Markov
      chain over parallel chains}
  }
  There can be multiple dimensions with tag "value" but at most one with
  tag "iteration" and at most one with tag "chain".
}
\author{Martyn Plummer}
\keyword{models}
\seealso{\code{\link{collapse}}}
